var Media = function() {
    this.startTime = [];
    this.$buffering = $('.buffer .buffering');
    this.$playing = $('.buffer .playing');
    this.$playButton = $('.playControl #playButton a');
    this.$pause = $('.playControl .pause a');
    this.$pre = $('.playControl .pre a');
    this.$next = $('.playControl .next a');
    this.$repeatButton = $('.modeControls #repeatControl a');
    this.$translateButton = $('.modeControls #translateControl a');
    this.$modeButton = $('.modeControls #modeControl a');
    this.$soundButton = $('.modeControls .sound a');
    this.$positionControl = $('.buffer .positionControl');
    this.$volumeControl = $('.volumeControl .soundControl');
    this.$sounds = $('.volumeControl .sounds');
    this.$loading = $('.playInfo .itemState');
    this.repeatStates = ['repeat,循环播放', 'repeated,单篇循环播放', 'repeatSen,单句循环播放'];
    this.repeatIndex = 0;
    this.repeatState = Tools.getLocalStorage('repeatState');
    this.modeState = Tools.getLocalStorage('modeState');
    this.translateState = '';
    this.volume = parseInt(Tools.getLocalStorage('volume'));
    this.articleIndex = 0;
    this.startMedia = false;
};
Media.prototype.getData = function(key) {
    return this[key];
};
Media.prototype.init = function(obj) {
    var volume = this.volume,
        top = 100 - volume + 10;
    if (!this.repeatState) {
        this.repeatState = 'repeat,循环播放';
    }
    for (var i = 0, l = this.repeatStates.length; i < l; i++) {
        if (this.repeatStates[i] == this.repeatState) {
            this.repeatIndex = i;
            break;
        }
    }
    Qt.setState('repeat', this.repeatState.split(',')[0]);
    this.repeatState = this.repeatStates[this.repeatIndex];
    this.$repeatButton.parent().attr('class', this.repeatState.split(',')[0]);
    if (!this.modeState) {
        this.modeState = 'read,阅读模式';
    }
    Qt.setState('mode', this.modeState.split(',')[0]);
    this.$modeButton.parent().attr('class', this.modeState.split(',')[0]);
    this.$sounds.css({
        'height': volume,
        'top': top
    });
    this.$volumeControl.css({
        'top': top - 10
    });
    $('body').bind('keydown', function(e) {
        if (!e.ctrlKey) {
            e.preventDefault();
        }
    }).bind('keyup', function(e) {
        if (!e.ctrlKey) {
            e.preventDefault();
        }
        switch (e.which) {
            case 37: //left
                obj.pre();
                break;
            case 38: //up
                if ($('.volumeControl').css('display') == 'none') {
                    $('.volumeControl').css({
                        'display': 'block'
                    });
                }
                if (obj.volume >= 100) {
                    obj.volume = 100;
                } else {
                    if (obj.volume <= 0) {
                        obj.volume = 0;
                        obj.$soundButton.parent().removeClass('mute');
                    }
                    obj.volume += 10;
                }
                obj.setVolume();
                break;
            case 39: //right
                obj.next();
                break;
            case 40: //down
                if ($('.volumeControl').css('display') == 'none') {
                    $('.volumeControl').css({
                        'display': 'block'
                    });
                }
                if (obj.volume == 0) {
                    obj.volume = 0;
                } else {
                    if (obj.volume == 10) {
                        obj.$soundButton.parent().addClass('mute');
                    }
                    obj.volume -= 10;
                }
                obj.setVolume();
                break;
            case 32: //blank
                obj.playControl();
                break;
            case 77:
                obj.modeControl();
                break;
            case 82: //r
                obj.repeatControl();
                break;
            case 84: //t
                obj.translateControl();
                break;
        };
    }).bind('mouseup', function() {
        if ($('.volumeControl').css('display') == 'block') {
            $('.volumeControl').hide();
        }
        $('body').unbind('mousemove');
        document.onselectstart = null;
    });
    this.$playButton.bind('click', function() {
        obj.playControl();
    });
    this.$pre.bind('click', function() {
        obj.pre();
    });
    this.$next.bind('click', function() {
        obj.next();
    });
    this.$translateButton.bind('click', function() {
        obj.translateControl();
    });
    this.$repeatButton.bind('click', function() {
        obj.repeatControl();
    });
    this.$modeButton.bind('click', function() {
        obj.modeControl();
    });
    this.$soundButton.bind('click', function() {
        switch ($('.volumeControl').css('display')) {
            case 'none':
                $('.volumeControl').show();
                break;
            case 'block':
                $('.volumeControl').hide();
                break;
        }
    }).bind('mouseup', function(e) {
        e.stopPropagation();
    });
    this.$volumeControl.bind('mousedown', function() {
        document.onselectstart = function() {
            return false;
        }
        $('body').bind('mousemove', function(e) {
            obj.volumeMove(e);
        }).one('mouseup', function(e) {

        });
    });
    this.$positionControl.bind('mousedown', function() {
        Qt.setLoadPositionState('true');
        var position;
        document.onselectstart = function() {
            return false;
        }
        $('body').bind('mousemove', function(e) {
            position = obj.positionMove(e);
        }).one('mouseup', function(e) {
            Qt.loadPosition(position);
            obj.$playButton.parent().attr('class', 'pause');
        });
    });
};
Media.prototype.positionMove = function(e) {
    var left = e.pageX - $('.bufferC').offset().left - parseInt($('.bufferC').css('padding-left')),
        width = $('.bufferC').width(),
        position;
    if (left >= 0 && left <= width) {
        position = parseInt(left / width * 100);
        this.$positionControl.css({
            'left': position + '%'
        });
    } else {
        if (left < 0) {
            position = 0;
        }
        if (left > width) {
            position = 99;
        }
    }
    this.setPlaying(position);
    return position;
};
Media.prototype.volumeMove = function(e) {
    var top = e.pageY - $('.volume').offset().top;
    if (top >= 100) {
        top = 100;
        this.$soundButton.parent().addClass('mute');
    } else {
        if (this.$soundButton.parent().hasClass('mute')) {
            this.$soundButton.parent().removeClass('mute');
        }
        if (top <= 0) {
            top = 0;
        }
    }
    top = 100 - top;
    this.volume = top;
    this.setVolume();
};
Media.prototype.cancelPlay = function() {
    this.$playButton.parent().removeClass('pause').addClass('play');
    Qt.cancelPlay();
};
Media.prototype.initPlay = function(data, type) {
    $('.wrap').scrollTop(0);
    if (this.startMedia == false) {
        this.startMedia = true;
        this.init(this);
    }
    this.articleIndex = article.getData('index');
    var htmlNode = $('.wrap')[0],
        htmlSource = htmlNode.innerHTML,
        v1 = htmlSource.match(/[0-5][0-9]\:[0-5][0-9]\.[0-9][0-9]/g),
        v2 = htmlSource.match(/([0-1][0-9]|2[0-3])\:[0-5][0-9]\:[0-5][0-9]/g);
    if (v1) {
        htmlNode.innerHTML = htmlSource.replace(/(["_,])(\d\d\:\d\d\.\d\d)/g, '$100:$2');
    }
    if (v2) {
        htmlNode.innerHTML = htmlSource.replace(/(["_,])(\d\d\:\d\d\:\d\d)/g, '$1$2.00');
    }
    this.startTime = $('#J_CIKU_sentence_time_range').val().split(',');
    var st = this.startTime,
        t, sts = [];
    for (var i = 0, l = st.length; i < l; i++) {
        t = this.getTransformTimes(st[i]);
        sts.push(t);
    }
    this.setBuffering(0);
    this.setPlaying(0);
    this.highlight(0);
    Qt.initPlay(data, type, sts);
};
Media.prototype.getTransformTimes = function(time) {
    var st = time.split('.')[0].split(':'),
        t = st[0] * 3600 + st[1] * 60 + st[2] * 100 / 100;
    t += time.split('.')[1] / 100;
    t *= 1000;
    return t;
};
Media.prototype.highlight = function(index) {
    var stamp = this.startTime[index];
    article.highlight(stamp);
};
Media.prototype.playControl = function() {
    switch (this.$playButton.parent().attr('class')) {
        case 'play':
            this.play(0);
            break;
        case 'pause':
            this.pause();
            break;
    }
};
Media.prototype.play = function(t) {
    this.$playButton.parent().removeClass('play').addClass('pause');
    Qt.play(t);
};
Media.prototype.pause = function() {
    this.$playButton.parent().removeClass('pause').addClass('play');
    Qt.pause();
};
Media.prototype.translateControl = function() {
    var translateState = this.translateState;
    if (/translateOn/.test(translateState)) {
        this.translateState = 'translateOff,已关闭译文';
        article.setLrc('off');
        Qt.setTranslationState('off');
    }
    if (/translateOff/.test(translateState)) {
        this.translateState = 'translateOn,已打开译文';
        article.setLrc('on');
        Qt.setTranslationState('on');
    }
};
Media.prototype.setTranslationState = function(translateState) {
    this.translateState = translateState;
    this.$translateButton.parent().attr('class', this.translateState.split(',')[0]);
    this.$translateButton.attr('title', this.translateState.split(',')[1] + '，可使用t键切换');
};
Media.prototype.repeatControl = function() {
    this.repeatIndex += 1;
    if (this.repeatIndex == this.repeatStates.length) {
        this.repeatIndex = 0;
    }
    this.repeatState = this.repeatStates[this.repeatIndex];
    Qt.setState('repeat', this.repeatState.split(',')[0]);
    this.$repeatButton.parent().attr('class', this.repeatState.split(',')[0]);
    this.$repeatButton.attr('title', this.repeatState.split(',')[1] + '，可使用r键切换');
    Tools.setLocalStorage('repeatState', this.repeatState);
    Qt.saveData('repeatState', this.repeatState);
};
Media.prototype.modeControl = function() {
    var modeState;
    if (/read/.test(this.modeState)) {
        modeState = 'dictation,听写模式';
    }
    if (/dictation/.test(this.modeState)) {
        modeState = 'read,阅读模式';
    }
    this.modeState = modeState;
    article.setMode(this.modeState.split(',')[0]);
    Qt.setState('mode', this.modeState.split(',')[0]);
    this.$modeButton.parent().attr('class', this.modeState.split(',')[0]);
    this.$modeButton.attr('title', this.modeState.split(',')[1] + '，可使用m键切换');
    Tools.setLocalStorage('modeState', this.modeState);
    Qt.saveData('modeState', this.modeState);
};
Media.prototype.pre = function() {
    this.cancelPlay();
    var index = this.articleIndex,
        articleLen = articleList.getData('data').length,
        articleData;
    index = index - 1;
    if (index == -1) {
        Qt.showInfo('该文章已是本频道的第一篇文章了');
        return;
    }
    articleData = articleList.getData('data')[index];
    article.setData('index', index);
    article.setData('data', articleData);
    article.setData('id', articleData['uuid']);
    var $spTitle = $('#level3').find('dl').eq(index).find('.sp-title');
    article.init($spTitle);
};
Media.prototype.next = function() {
    this.cancelPlay();
    var index = this.articleIndex,
        articleLen = articleList.getData('data').length,
        articleData, downloadState;
    index = index + 1;
    this.articleIndex = index;
    if (index == articleLen) {
        Qt.showInfo('该文章已是本频道的最后一篇听力了');
        return;
    }
    articleData = articleList.getData('data')[index];
    downloadState = articleData['downloadState'];
    if (downloadState != 'downloaded') {
        this.next();
    } else {
        article.setData('index', index);
        article.setData('data', articleData);
        article.setData('id', articleData['uuid']);
        var $spTitle = $('#level3').find('dl').eq(index).find('.sp-title');
        article.init($spTitle);
    }
};
Media.prototype.setBuffering = function(position) {
    position = position + '%';
    this.$buffering.css({
        'width': position
    });
};
Media.prototype.loadingStart = function() {
    this.$playButton.removeClass('pause').addClass('play');
    this.$loading.show();
};
Media.prototype.loadingEnd = function() {
    this.$playButton.removeClass('play').addClass('pause');
    this.$loading.hide();
};
Media.prototype.setPlaying = function(position) {
    position = position + '%';
    this.$playing.css({
        'width': position
    });
    this.$positionControl.css({
        'left': position
    });
};
Media.prototype.playEnd = function() {
    switch (this.repeatState.split(',')[0]) {
        case 'repeatSen':
            var $node = $('.sentence'),
                startTime = $node.eq($node.size() - 1).attr('data-starttime');
            startTime = this.getTransformTimes(startTime);
            this.play(startTime);
            break;
        case 'repeat':
            this.next();
            break;
        case 'repeated':
            $('.wrap').scrollTop(0);
            this.play(0);
            break;
    }
};
Media.prototype.setVolume = function() {
    var volume = this.volume,
        top = 100 - volume + 10;
    this.$sounds.css({
        'height': volume,
        'top': top
    });
    this.$volumeControl.css({
        'top': top - 10
    });
    Qt.setVolume(this.volume);
};
var media = new Media();