var UI = function() {
    this.$pushContainer = null;
    this.initPush();
};
UI.prototype.initPush = function() {
    var pushContainer = document.createElement('div');
    pushContainer.className = 'pushContainer';
    pushContainer.innerHTML = '<p class="pushMsg"></p>';
    var $pushContainer = $(pushContainer);
    $('.sideNav').append($pushContainer);
    this.$pushContainer = $pushContainer;
};
UI.prototype.pushMessage = function(msg) {
    var self = this;
    this.$pushContainer.find('.pushMsg').text(msg).fadeIn();
    setTimeout(function() {
        self.$pushContainer.find('.pushMsg').fadeOut();
    }, 600);
};
var ui = new UI();

//Qt static collection
var Qt = {
    openWindow: function(url) {
        WebApi.openBrowser(url);
    },
    showInfo:function(str){
        WebApi.showInfo(str);
    },
    captureWord:function(url){
        WebApi.captureWord(url);
    },
    saveData: function(key, value){
        WebApi.saveData(key, value);
    },
    pageLoaded: function() {
        WebApi.pageLoaded('');
        WebApi.getZipDir();
    },
    downloadArticle: function(articleData) {
        WebApi.downloadArticle(articleData);
    },
    downloadChannel: function(channelData) {
        WebApi.downloadChannel(channelData);
    },
    updateArticleData: function(articleId, articleData) {
        WebApi.updateArticleData(articleId, articleData);
    },
    deleteArticleData:function(articleId, channelId){
        WebApi.deleteArticleData(articleId, channelId);
    },
    deleteChannelData:function(channelId){
        WebApi.deleteChannelData(channelId);
    },
    gotoOnline: function() {
        WebApi.cancelPlay();
        WebApi.gotoOnline();
        WebApi.setPrintAble(false);
    },
    setHtmlPage:function(data, titleName){
        WebApi.setHtmlPage(data, titleName);
    },
    setPrintAble: function(able) {
        WebApi.setPrintAble(able);
    },
    resetMedia:function(){
        WebApi.resetMedia();
    },
    initPlay: function(src, type, startTime) {
        WebApi.initPlay(src, type, startTime);
    },
    play: function(t) {
        WebApi.play(t);
    },
    pause: function() {
        WebApi.pause();
    },
    setVolume: function(volume) {
        WebApi.setVolume(volume);
    },
    cancelPlay: function() {
        WebApi.cancelPlay();
    },
    loadPosition:function(position){
        WebApi.loadPosition(position);
    },
    setState: function(stateName, state) {
        WebApi.setState(stateName, state);
    },
    setLoadPositionState: function(loadPositionState) {
        WebApi.setLoadPositionState(loadPositionState);
    },
    setDictationIndex: function(index) {
        WebApi.setDictationIndex(index);
    },
    setPlayIndex: function(index) {
        WebApi.setPlayIndex(index);
    },
    setTranslationState: function(state) {
        WebApi.setTranslationState(state);
    }
};



//toolkits
var Tools = {
    getLocalStorage: function(key) {
        var listen = JSON.parse(window.localStorage.getItem('listen'));
        if (!listen) {
            return null;
        } else {
            return listen[key];
        }
    },
    setLocalStorage: function(key, value) {
        var listen;
        if (window.localStorage.getItem('listen')) {
            listen = JSON.parse(window.localStorage.getItem('listen'));
        } else {
            listen = {};
        }
        listen[key] = value;
        window.localStorage.setItem('listen', JSON.stringify(listen));
    },
    removeLocalStorage: function(key) {
        var listen = JSON.parse(window.localStorage.getItem('listen'));
        listen[key] = '';
        window.localStorage.setItem('listen', JSON.stringify[listen]);
    },
    setCookie: function(name, value) {
        var expires = new Date(),
            cookies = '';
        expires.setTime(expires.getTime() + 24 * 60 * 60 * 365 * 50000);
        for (var i = 0, len = name.length; i < len; i++) {
            cookies = cookies + name[i] + '=' + value[i] + ';';
        }
        document.cookie = cookies + 'expires=' + expires.toGMTString();
    },
    getCookie: function(name) {
        var cookies = document.cookie.split(';'),
            len = cookies.length,
            mycookie;
        for (var i = 0; i < len; i++) {
            mycookie = cookies[i].split('=')[0].replace(/\s*/, '');
            if (name == mycookie) {
                return cookies[i].split('=')[1];
                break;
            }
        }
    }
};



//software resource
var SoftWare = {
    'fr': {
        'name': '法语助手',
        'url': 'http://frdic.com/ting',
        'purchase': 'http://ting.frdic.com/ting/purchase',
        'productid': 1
    },
    'de': {
        'name': '德语助手',
        'url': 'http://www.godic.net/ting',
        'purchase': 'http://www.godic.net/ting/purchase',
        'productid': 9
    },
    'es': {
        'name': '西语助手',
        'url': 'http://www.esdict.cn/ting',
        'purchase': 'http://www.esdict.cn/ting/purchase',
        'productid': 31
    },
    'en': {
        'name': '欧路词典',
        'url': 'http://dict.eudic.net/ting',
        'purchase': 'http://dict.eudic.net/ting/purchase',
        'productid': 23
    }
};



//slideNav toolkit
var SlideNav = function() {
    var self = this;
    this.$slideControl = $('#slideControl');
    $('#sideBar').click(function(e) {
        if ($(e.target).attr('id') == 'sideBar') {
            self.slideOut();
        }
    });
    $('.sideNav').click(function(e) {
        if ($(e.target).attr('class') == 'sideNav') {
            self.slideOut();
        }
    })
    $('.slideWidget').click(function() {
        switch ($('.slideWidget #slideControl').attr('class')) {
            case 'slideOut':
                self.slideIn();
                break;
            case 'slideIn':
                self.slideOut();
                break;
        }
    });
};
SlideNav.prototype.slideIn = function() {
    for (var i = 0; i <= 100; i += 5) {
        (function(i) {
            setTimeout(function() {
                $('.sideNav').css('margin-left', function() {
                    return 0 + i / 5 * 16;
                });
            }, (i + 1) * 2);
        }(i));
    }
    this.$slideControl.attr('class', 'slideIn');
    $('#sideBar').fadeIn();
};
SlideNav.prototype.slideOut = function() {
    if (this.$slideControl.hasClass('slideIn')) {
        $('#sideBar').fadeOut();
        for (var i = 0; i <= 100; i += 5) {
            (function(i) {
                setTimeout(function() {
                    $('.sideNav').css('margin-left', function() {
                        return 320 - i / 5 * 16;
                    });
                }, (i + 1) * 2);
            }(i));
        }
        this.$slideControl.attr('class', 'slideOut');
    }
};
SlideNav.prototype.In = function(){
    this.$slideControl.attr('class', 'slideIn');
    $('.sideNav').css({'margin-left':'320px'});    
    $('#sideBar').show();
};
var slideNav = new SlideNav();

function setData(key, value){
    Tools.setLocalStorage(key, value);
}